#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
//#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
//#include <sys/socket.h>
#include <sys/stat.h>
//#include <netinet/in.h>>
#include <dirent.h>
//#include <sys/wait.h>

/** Gestore morte dei figli **/
void gestore(int signo)
{
  int stato;
  wait(&stato);
}
/****/

int main(int argc, char **argv)
{
  int  listen_sd, conn_sd;
  int port, len, num1;
  const int on = 1;
  struct sockaddr_in cliaddr, servaddr;
  struct hostent *host;

  /** Controllo argomenti **/
  if(argc!=2){
    printf("Error: %s port\n", argv[0]);
    exit(1);
  } else{
    num1=0;
    while( argv[1][num1]!= '\0' ){
      if( (argv[1][num1] < '0') || (argv[1][num1] > '9') ){
        printf("Secondo argomento non intero\n");
        exit(2);
      }
      num1++;
    }	
  	port = atoi(argv[1]);
  	if (port < 1024 || port > 65535) 
  	{
      printf("Error: %s port\n", argv[0]);
      printf("1024 <= port <= 65535\n");
      exit(2);  	
  	}
  }
  /****/

  /** Apertura socket server **/
  memset ((char *)&servaddr, 0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = INADDR_ANY;
  servaddr.sin_port = htons(port);
  if((listen_sd=socket(AF_INET, SOCK_STREAM, 0)) <0){
    perror("creazione socket ");
    exit(1);
  } else if(setsockopt(listen_sd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0){
    perror("set opzioni socket d'ascolto");
    exit(1);
  }
  if(bind(listen_sd,(struct sockaddr *) &servaddr, sizeof(servaddr))<0){
    perror("bind socket d'ascolto");
    exit(1);
  }
  if (listen(listen_sd, 5)<0){
    perror("listen");
    exit(1);
  }
  /****/
  
  /** Ascoltatore terminazione figli **/
  signal(SIGCHLD, gestore);
  /****/

  /** Ciclo di ascolto richieste **/
  printf("Server ON\n");fflush(stdout);
  for(;;){ 
  	len=sizeof(cliaddr);
    if((conn_sd=accept(listen_sd,(struct sockaddr *)&cliaddr,&len))<0){
      /* La accept potrebbe essere interrotta dai segnali SIGCHLD inviati dai figli
       * alla loro terminazione. Tale situazione va gestita opportunamente.
       */
      if (errno==EINTR){
        perror("Forzo la continuazione della accept");
        continue;
      } else exit(1);
    }
    int f=fork();
    if (f==0){ // figlio
      close(listen_sd);
      if ((host=gethostbyaddr( (char *) &cliaddr.sin_addr, sizeof(cliaddr.sin_addr), AF_INET)) == NULL){
        printf("client host information not found\n");
        continue;
      } else printf("Server (figlio): l'host client e' %s \n", host->h_name);
      /** Codice del figlio che gestisce la richiesta **/
      char nomeDir[FILENAME_MAX+1];
      int letti,chDir;
      while(1){
        num1=0;
        bzero(nomeDir,FILENAME_MAX+1);
        while(1){
          read(conn_sd,&nomeDir[num1],sizeof(char));
          if(nomeDir[num1]=='\0') break;
          num1++;
        }
        // ciclo di invio file
        char nomeFile[FILENAME_MAX+1],c;
        int fileSize,num2,n,n2;
        FILE* file;
        //apertura cartella
        DIR* dir;
        if( (dir = opendir(nomeDir)) < 0){
          perror("Apertura directory");
          nomeFile[0]='\0';
          write(conn_sd,nomeFile,sizeof(char));
          write(conn_sd,-1,sizeof(int));
          closedir(dir);
          close(conn_sd);
          exit(0);
        }
        struct dirent** nameList;
        n=scandir(nomeDir,&nameList,0,0);
        chDir=chdir(nomeDir);
        closedir(dir);
        for(num1=0;num1<n;num1++){
          if(nameList[num1]->d_type != DT_REG){
            continue;
          }
          bzero(nomeFile,FILENAME_MAX+1);
          strcpy(nomeFile,nameList[num1]->d_name);
          struct stat stbuf;
          stat(nomeFile, &stbuf);
          fileSize = stbuf.st_size;
          //invio sullo stream di nome e dimensione
          write(conn_sd,&nomeFile,strlen(nomeFile)+1);
          int nFileSize = htonl(fileSize);
          write(conn_sd,&nFileSize,sizeof(int));
          
          /** Inserire qui il protocollo di comunicazione **/
          // aprire il file in lettura
          if( (file=fopen(nomeFile,"r")) < 0 ){
            perror("Apertura file");
            break;
          }
          //inviare i caratteri (se ne aspettano fileSize in lettura)
          for(n2=0;n2<fileSize;n2++){
            if( fread(&c,1,sizeof(char),file) < 0 ){
              perror("Lettura da file");
              break;
            }
            if( write(conn_sd,&c,sizeof(char)) < 0 ){
              perror("Scrittura su socket");
              break;
            }
          }       
          //chiusura file
          if( (fclose(file)) < 0){
            perror("chiusura file");
            continue;
          }
          /****/
        }
        if(chDir==0) chdir("..");
        write(conn_sd,"END",4*sizeof(char));
        num1 = htonl(-1);
        write(conn_sd,&num1,sizeof(int));
      }
      close(conn_sd);
      exit(0);
      /****/ //fine codice figlio
    } else if(f>0){
      close(conn_sd);
      /** Codice del padre **/
      
      /****/ //fine codice padre
    } else{
      perror("fork");
      exit(2);
    }
  }
  /****/ //ciclo infinito del server
}

